/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Le Framework de jeux JavaScript Phaser
 *
Phaser v2.0.5 - http://phaser.io - @photonstorm - (c) 2014 Photon Storm Ltd. 
https://github.com/photonstorm/phaser
http://examples.phaser.io/
 */



/**
 * Classe de préchargement de tous les éléments du jeu
 * 
 * @param  {[type]} game [description]
 * @return {[type]}      [description]
 */


/**
 * Les variables du jeu
 * 
 */

// how many pages are needed to show all levels?
var pages;
// group where to place all level thumbnails
var levelThumbsGroup;
// current page
var currentPage;
// arrows to navigate through level pages
var leftArrow;
var rightArrow;


levelSelect = {

/**
 * Les méthodes
 * 
 * @type {Object}
 */



	/**
	 * Création de la scène du jeu,
	 * mise en place des graphismes...
	 * 
	 * @return {[type]} [description]
	 */	
  	create: function()
  	{
  		// détermine le nombre de pages nécessaires pour afficher tous les niveaux
		// CAUTION!! EACH PAGE SHOULD HAVE THE SAME AMOUNT OF LEVELS, THAT IS
		// THE NUMBER OF LEVELS *MUST* BE DIVISIBLE BY THUMBCOLS*THUMBROWS
  		pages = game.global.starsArray.length / (game.global.thumbRows*game.global.thumbCols);
  		
  		// current page according to last played level, if any
		currentPage = Math.floor(game.global.level/(game.global.thumbRows*game.global.thumbCols));
		if(currentPage>pages-1)
			currentPage = pages-1;
		
		// flèche gauche afficher la page précédente
		leftArrow = game.add.button(50, 420, "level_arrows", this.btnNextPrevClic,this);
		leftArrow.anchor.setTo(0.5);
		leftArrow.frame = 0;

		// page précédente possible ?
		if( currentPage == 0 )
			leftArrow.alpha = 0.3;// non - désactive le bouton précédent
		
		// flèche droite afficher la page suivante
		rightArrow = game.add.button(270, 420, "level_arrows", this.btnNextPrevClic,this);
		rightArrow.anchor.setTo(0.5);
		rightArrow.frame = 1;

		// page suivant possible ?
		if(currentPage==pages-1)
			rightArrow.alpha = 0.3;// non - désactive le bouton suivant
		
		// creation d'un groupe de miniature
		levelThumbsGroup = game.add.group();

		// determining level thumbnails width and height for each page
		// calcul les largeurs et hauteurs des miniatures pour chaque page
		var levelLength = game.global.thumbWidth * game.global.thumbCols+game.global.thumbSpacing * (game.global.thumbCols-1);
		var levelHeight = game.global.thumbWidth * game.global.thumbRows+game.global.thumbSpacing * (game.global.thumbRows-1);
		
		// boucle sur chaque page
		for(var l = 0; l < pages; l++)
		{
			// ajustement horizontal pour centrer les miniatures sur la page
			var offsetX = (game.width-levelLength)/2+game.width*l;

			// pour centrer les miniatures verticalement sur la page
			// remplacez "20" par
			// (game.height-levelHeight)/2
			var offsetY = 20;

			// boucle sur chaque bouton "choix du niveau"
		    for(var i = 0; i < game.global.thumbRows; i ++)
		    {
		     	for(var j = 0; j < game.global.thumbCols; j ++)
		     	{  
		     		// which level does the thumbnail refer?
					var levelNumber = i*game.global.thumbCols+j+l*(game.global.thumbRows*game.global.thumbCols);
					
					// positionne et affiche la miniature, fonctionnement d'un bouton, appel la fonction btnLevelClic		
					var levelThumb = game.add.button(offsetX+j*(game.global.thumbWidth+game.global.thumbSpacing), offsetY+i*(game.global.thumbHeight+game.global.thumbSpacing), "levels", this.btnLevelClic, this);	
					
					// affiche la frame / l'image correcte
					levelThumb.frame = game.global.starsArray[levelNumber];
					
					// création d'un attribut personnalisé sur l'objet 
					levelThumb.levelNumber = levelNumber+1;// état du niveau (terminé, en cours, bloqué)
					
					// adding the level thumb to the group
					levelThumbsGroup.add(levelThumb);
					
					// si le niveau est jouable, ajout du numéro du niveau
					if( game.global.starsArray[levelNumber] < 4 )
					{
						var style = {
							font: "18px Arial",
							fill: "#00C5DF"
						};

						// le texte à afficher
						var nNumLevel = levelNumber+1
						var sTextLevel = "Niv. "+nNumLevel+" ";

						var levelText = game.add.text(levelThumb.x+5,levelThumb.y+5, sTextLevel,style);
						levelText.setShadow(2, 2, "#006f77", 1);// ajout un effet d'ombre
						levelThumbsGroup.add(levelText);
					}
				}
			}
		}
		// scrolling thumbnails group according to level position
		levelThumbsGroup.x = currentPage * game.width * -1
	},


	/**
	 * Clic sur la flèche gauche ou droite
	 * Affiche la page suivante avec tous les niveaux
	 * 
	 * @param  {[type]} button [description]
	 * @return {[type]}        [description]
	 */
	btnNextPrevClic:function(button)
	{
		// clic sur le bouton suivant et si pas dernière page
		if(button.frame==1 && currentPage<pages-1)
		{
			leftArrow.alpha = 1;
			currentPage++;

			// désactive le bouton suivante si dernière page
			if(currentPage == pages-1)
				button.alpha = 0.3;
			
			// animation de défilement de page
			var buttonsTween = game.add.tween(levelThumbsGroup);
			buttonsTween.to({x: currentPage * game.width * -1}, 500, Phaser.Easing.Cubic.None);
			buttonsTween.start();
		}

		// clic sur le bouton précédent et si pas première page
		if(button.frame==0 && currentPage>0)
		{
			rightArrow.alpha = 1;
			currentPage--;

			// désactive le bouton précédent si première page
			if(currentPage == 0)
				button.alpha = 0.3;
			
			// animation de défilement de page
			var buttonsTween = game.add.tween(levelThumbsGroup);
			buttonsTween.to({x: currentPage * game.width * -1}, 400, Phaser.Easing.Cubic.None);
			buttonsTween.start();
		}		
	},


	/**
	 * Clic sur un niveau
	 * Prépare l'interface "niveau en cours de jeu"
	 * 
	 * @param  {[type]} button [description]
	 * @return {[type]}        [description]
	 */
	btnLevelClic:function(button)
	{
		// si le niveau n'est pas bloqué, alors affiche l'interface de jeu du niveau
		if(button.frame < 4)
		{
			game.global.level = button.levelNumber;
			game.state.start("PlayLevel");// lance l'interface "niveau en cours de jeu"
		}
		// sinon affiche un effet de blocage sur la miniature du niveau concerné
		else
		{
			var buttonTween = game.add.tween(button)
			buttonTween.to({alpha: 0.5}, 20, Phaser.Easing.Cubic.None);
			buttonTween.to({alpha: 1}, 20, Phaser.Easing.Cubic.None);
			buttonTween.to({alpha: 0.5}, 20, Phaser.Easing.Cubic.None);
			buttonTween.to({alpha: 1}, 20, Phaser.Easing.Cubic.None);
			buttonTween.start();
		}
	}
} 