/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Le Framework de jeux JavaScript Phaser
 *
Phaser v2.0.5 - http://phaser.io - @photonstorm - (c) 2014 Photon Storm Ltd. 
https://github.com/photonstorm/phaser
http://examples.phaser.io/
 */



/**
 * Les variables du jeu
 * 
 */

var game; 

var nWidth = 320;
var nHeight = 480;


document.addEventListener("DOMContentLoaded", Main, false); // appel au chargement de la page


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // creation de la zone de jeu - API canvas
    game = new Phaser.Game(nWidth, nHeight, Phaser.AUTO, "idGameDiv", {preload:onPreload, create:onCreate, update:onUpdate});

    // les variables globales du jeu
    game.global = {
        thumbRows : 5,// nombre d'icone par ligne
        thumbCols : 4,// nombre d'icone par colonnes

        thumbWidth : 64,// largeur d'une miniature en pixels
        thumbHeight : 64,// hauteur d'une miniature en pixels
        thumbSpacing : 8,// espace entre les miniatures en pixels

        // tableau avec les niveaux terminés et les étoiles collectées.
        // 0 = niveau non terminé et jouable
        // 1, 2, 3 = niveau terminé avec 1, 2, 3 étoiles
        // 4 = niveau bloqué
        starsArray : [0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4],

        level : 0// niveau en cours de jeu
    }

    // ajout de tous les écrans du jeu
    game.state.add("Loading", loading);
    game.state.add("LevelSelect", levelSelect);
    game.state.add("PlayLevel", playLevel);

    // lance le premier écran du jeu (chargement en cours)
    game.state.start("Loading");
}


/**
 * Préchargement des éléments du jeu
 * 
 * @return {[type]} [description]
 */
function onPreload()
{ 
}



/**
 * Création de la scène du jeu,
 * mise en place des graphismes...
 * 
 * @return {[type]} [description]
 */
function onCreate() 
{
}


/**
 * Appelée en continu pendant le jeu
 * 
 * @return {[type]} [description]
 */
function onUpdate() 
{
}



